# (Explorer Workshop)
# Copyright: 2024 Bradan Lane STUDIO
#
# Open Source License: MIT

'''
This Python program is a sample from the 'Python' workshop

Implementation Notes
--------------------
**Hardware:**
    * computer

**Software and Dependencies:**
    * Python 3.x
    * Thonny 4.x IDE

**Open Source Repository:**
    * GitLab: https://gitlab.com/bradanlane/exp_tutorial
    
'''

print("Hello World!")

# read all of the contents of a file and print it to the serial console
finished: bool = False
line: str
filename: str = "data/text.txt"

MAX_LEN = 50

try:
    data_file = open(filename, "r")
except Exception as e:
    print("error opening file", e)
    finished = True # no file to process

# the use of 'While True:' creates an infinite loop where code will run forever ... or until an error occurs :-)
while not finished:
    line = data_file.readline()
    if not line:
        finished = True
        data_file.close()
        print("\n - end of file - ")
    else:
        line = line.strip("\n")
        if len(line) < MAX_LEN:
            padding = (MAX_LEN - len(line)) // 2
            print(" " * padding, end="")
        print(line)

print("Good Bye")
